//From: https://developer.mozilla.org/en-US/docs/WebGL/Getting_started_with_WebGL

function getShader(id) {
	var shaderScript, theSource, currentChild, shader;
	 
	shaderScript = document.getElementById(id);
	 
	if (!shaderScript) {
		return null;
	}
	 
	theSource = "";
	currentChild = shaderScript.firstChild;
	 
	while(currentChild) {
		if (currentChild.nodeType == currentChild.TEXT_NODE) {
			theSource += currentChild.textContent;
		}
	   
		currentChild = currentChild.nextSibling;
	}
	if (shaderScript.type == "x-shader/x-fragment") {
		shader = gl.createShader(gl.FRAGMENT_SHADER);
	} else if (shaderScript.type == "x-shader/x-vertex") {
		shader = gl.createShader(gl.VERTEX_SHADER);
	} else {
		// Unknown shader type
		return null;
	}
	gl.shaderSource(shader, theSource);
	   
	// Compile the shader program
	gl.compileShader(shader);  
	   
	// See if it compiled successfully
	if (!gl.getShaderParameter(shader, gl.COMPILE_STATUS)) {  
		alert("An error occurred compiling the shaders: " + gl.getShaderInfoLog(shader));  
		return null;  
	}
	   
	return shader;
}

function getProgram(vertId,fragId) {
	var vertexShader = getShader(vertId);
	var fragmentShader = getShader(fragId);
   
	// Create the shader program
   
	var program = gl.createProgram();
	gl.attachShader(program, vertexShader);
	gl.attachShader(program, fragmentShader);
	gl.linkProgram(program);
   
	// If creating the shader program failed, alert
	if (!gl.getProgramParameter(program, gl.LINK_STATUS)) {
		alert("Unable to initialize the shader program.");
		return null;
	}

	return program;
}

